/*
 * GraphBOM.java
 *
 * Created on 18 de marzo de 2005, 22:28
 */

package BOM;

import java.awt.Point;
import oracle.FactorOracle;
import java.util.ArrayList;

/**
 *
 * @author Alejandro Touza Paredes
 *
 * 
 */
public class BackwardsOracleMatching{
    
    private FactorOracle fo;
    private String text;
    private int currentChar;
    // Nmero de caracteres coincidentes entre sufijo y prefijo para el pattern del GraohOracle
    private int commonPrefix;
    private int patternLength;
    // Posiciones donde ha encontrado el pattern (para consultar)
    private ArrayList found;
    // Nmero de comparaciones realizadas para realizar la bsqueda
    private int numberOfComparisons;
    
    //CONSTRUCTORAS
    /** Crea una nueva instancia de BOM. */
    public BackwardsOracleMatching(String pattern, String text) {
        
        //Creamos un GraphOracle con el pattern invertido
        fo = new FactorOracle((new StringBuffer(pattern)).reverse().toString());
        fo.Oracle();
        
        found = new ArrayList();
        this.text = text;
        patternLength = pattern.length();
        currentChar = pattern.length();
        numberOfComparisons = 0;
        
        commonPrefix = calculateCommonPrefix(pattern);
     }
    
    /** Crea una nueva instancia de BOM. */
    public BackwardsOracleMatching(FactorOracle gor, String text) {
        
        fo = new FactorOracle(gor.pattern());
        fo.Oracle();
        this.text = text;
        patternLength = gor.pattern().length();
        currentChar = gor.pattern().length();
        
        commonPrefix = calculateCommonPrefix(fo.pattern());
     
    }
    /* REVISAR O BORRAR */
    private int calculateCommonPrefix(String s){
        
        int i = 0;
        //Se podra comprobar solo la mitad del String (Rehacer)
        for(i=0; i<s.length(); i++)
        {
            if(s.charAt(i) != s.charAt(s.length()-1 - i)) return i;
        }
        return i;
    }
    //MODIFICADORAS
    public void getGraphOracle(FactorOracle g){
        
        g = fo;
    }
    //CONSULTORAS 
    public String getText(){
        
        return text;
    }
    
    public String getPattern(){
        
        return fo.pattern();
    }
    
    public void setText(String text){
        
        this.text = text;
    }
    
    public void doBOM(ArrayList al){
        
        recursiveBOM(patternLength, 0, al);
        System.out.println("---------------- NUEVA BSQUEDA -------------------");  
        System.out.println("Longitud del texto                -> " + text.length());  
        System.out.println("Longitud del pattern              -> " + fo.pattern().length());
        System.out.println("Nmero de comparaciones           -> " + numberOfComparisons);
        System.out.println("Nmero de patterns coincidentes   -> " + found.size());
        float ratio = (float)text.length() / (float)numberOfComparisons;
        System.out.println("Se ha realizado 1 comparacin por cada " + ratio + " carcter/es");
        System.out.println("Posiciones de los patterns coincidentes: " + found + "\n");
    }
    
    private void recursiveBOM(int currentColumnEnd, int currentColumnStart, ArrayList al){
        
        if (text.length()>=currentColumnEnd)
        {
            int c = currentColumnEnd;
            
            // Invertimos el buffer a buscar
            StringBuffer bs = new StringBuffer(text.substring(currentColumnStart, currentColumnEnd));
            String s = new String(bs.reverse());
            // Realizamos la bsqueda del string actual
            Point searchResults = fo.search(s);
                
            // Si encontramos toda la palabra (shiftamos patternLength)
            // Habra que comprobar si el sufijo es tb prefijo (???)
            // (se puede hacer al principio una sola vez)
            
            // Hemos encontrado todo el pattern
            if(searchResults.x == patternLength)
            {
                found.add((currentColumnEnd - patternLength + 1)+"");
                numberOfComparisons+=patternLength;
                currentColumnEnd++;
            }
            // Hemos llegado a un nodo final o no encontramos ms caracteres
            else
            {
                currentColumnEnd += (patternLength - searchResults.x);
                numberOfComparisons += searchResults.x+1;
            }
            
            //1er Campo es la posicion del pattern
            //2o  Campo es el n de coincidencias encontradas
            al.add(new Point(currentColumnStart, searchResults.x));
            
            recursiveBOM(currentColumnEnd, currentColumnStart + (currentColumnEnd - c), al);
       }
    }
    
}

