/*
 * JFrameOracle.java
 *
 * Created on 23 de marzo de 2005, 16:20
 */

package learningbom;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;
import java.awt.event.WindowListener;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author Alejandro Touza Paredes
 */
public class ConsoleOracle extends javax.swing.JFrame {
    
    private MyCanvasOracle co;
    private JFrame jFrameMyCanvasOracle;
    private JPanel jPanelMyCanvasOracle;
    
    /** Crea una nueva instancia de ConsoleOracle */
    public ConsoleOracle() {
        
        setIconImage(Resources.createImageIcon("/images/icons/IconoProgramaConsolaOracle.gif").getImage());
        initComponents();
        //Repintamos el Canvas cada vez que se gane el foco
        this.addWindowFocusListener(new WindowFocusListener(){
            public void windowLostFocus(WindowEvent evt){}
            public void windowGainedFocus(WindowEvent evt){windowGainedFocusEvent();}
        });
        this.addWindowListener(new WindowListener(){
            public void windowOpened(WindowEvent evt){}
            public void windowIconified(WindowEvent evt){jFrameMyCanvasOracle.hide();}
            public void windowDeiconified(WindowEvent evt){jFrameMyCanvasOracle.show(); toFront();}
            public void windowDeactivated(WindowEvent evt){}
            public void windowClosing(WindowEvent evt){doClose();}
            public void windowClosed(WindowEvent evt){}
            public void windowActivated(WindowEvent evt){}
        });
        
        //Lo hacemos as para que en la barra de tareas ConsoleOracle aparezca antes
        //que MyCanvasOracle
        show();
        initMyCanvasOracle();
        jTextFieldPattern.requestFocus();
    }
    private void windowGainedFocusEvent(){
       
       if(co.isStarted())co.repaint();
   }
    private void initMyCanvasOracle(){
        
        jFrameMyCanvasOracle = new JFrame();
        jFrameMyCanvasOracle.setIconImage(Resources.createImageIcon("/images/icons/IconoProgramaConsolaOracle32x32.gif").getImage());
        jFrameMyCanvasOracle.setBounds(this.getX() + this.getWidth(), this.getY(),
                                    SystemScreenSize().width - this.getWidth(), 
                                    SystemScreenSize().height - 30);        
        jFrameMyCanvasOracle.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
           
        jFrameMyCanvasOracle.setVisible(true); //necesario para contener al Canvas
        jFrameMyCanvasOracle.setTitle("Factor Oracle");
        
        JPanel jPanelMyCanvasOracle = new JPanel();
        jPanelMyCanvasOracle = (JPanel)jFrameMyCanvasOracle.getContentPane();
        
        jPanelMyCanvasOracle.setPreferredSize(jFrameMyCanvasOracle.getSize());
        jPanelMyCanvasOracle.setLayout(null);
        co = new MyCanvasOracle(jPanelMyCanvasOracle);
        co.setDrawLink(true);
        
        co.addKeyListener(new KeyListener(){
            public void keyTyped(KeyEvent evt){ }
            public void keyReleased(KeyEvent evt){}
            public void keyPressed(KeyEvent evt){ MyCanvasOracleKeyPressed(evt);}
        });
        jFrameMyCanvasOracle.addKeyListener(new KeyListener(){
            public void keyTyped(KeyEvent evt){ }
            public void keyReleased(KeyEvent evt){}
            public void keyPressed(KeyEvent evt){ MyCanvasOracleKeyPressed(evt);}
        });
        co.setDefaultListeners(jFrameMyCanvasOracle, jPanelMyCanvasOracle);
    }
    private void MyCanvasOracleKeyPressed(KeyEvent evt){
   
        switch(evt.getKeyCode())
        {
            case KeyEvent.VK_SPACE:      if(jButtonStep.isEnabled()) doStep();
                                         break;
            case KeyEvent.VK_BACK_SPACE: if(jButtonStepBack.isEnabled()) doStepBack();
                                         break;
            case KeyEvent.VK_ENTER:      if(jButtonComplete.isEnabled()) doComplete();
                                         break;
            case KeyEvent.VK_B:          if(jButtonBOM.isEnabled())
                                         {   
                                            doGotoBOM();
                                         }
                                         break;                             
            case KeyEvent.VK_R:          if(jButtonReset.isEnabled()) doReset();
                                         break;
            case KeyEvent.VK_S:          doStart();
                                         break;
            case KeyEvent.VK_PLUS:       
            case KeyEvent.VK_ADD:        doBigger();
                                         break;
            case KeyEvent.VK_MINUS:      
            case KeyEvent.VK_SUBTRACT:   doSmaller();
                                         break;
            case KeyEvent.VK_F:          jCheckBoxFitToScreen.doClick();
                                         break;
            case KeyEvent.VK_C:          if(jButtonMoveToStart.isEnabled()) doMoveToStart();
                                         break;
            case KeyEvent.VK_LEFT:       doMove(100, 0);
                                         break;
            case KeyEvent.VK_RIGHT:      doMove(-100, 0);
                                         break;
            case KeyEvent.VK_UP:         doMove(0, 100);
                                         break;
            case KeyEvent.VK_DOWN:       doMove(0, -100);
                                         break;                                 
        }
   } 

    private Dimension SystemScreenSize() {   
        
        return Toolkit.getDefaultToolkit().getScreenSize();
   }  
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanelConsoleOracle = new javax.swing.JPanel();
        jPanelFactorOracle = new javax.swing.JPanel();
        jTextFieldPattern = new javax.swing.JTextField();
        jButtonStart = new javax.swing.JButton();
        jButtonReset = new javax.swing.JButton();
        jPanelSteps = new javax.swing.JPanel();
        jButtonStepBack = new javax.swing.JButton();
        jButtonStep = new javax.swing.JButton();
        jButtonComplete = new javax.swing.JButton();
        jPanelRedrawing = new javax.swing.JPanel();
        jTextFieldSize = new javax.swing.JTextField();
        jButtonResizeOK = new javax.swing.JButton();
        jButtonResizeBigger = new javax.swing.JButton();
        jButtonResizeSmaller = new javax.swing.JButton();
        jCheckBoxFitToScreen = new javax.swing.JCheckBox();
        jButtonMoveToStart = new javax.swing.JButton();
        jPanelHelp = new javax.swing.JPanel();
        jButtonBOM = new javax.swing.JButton();
        jButtonHelp = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridLayout(1, 0));

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Consola Factor Oracle");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setName("JFrameConsole");
        getAccessibleContext().setAccessibleDescription("Consola para Grafos Oracle");
        jPanelConsoleOracle.setBorder(new javax.swing.border.TitledBorder("Consola"));
        jPanelConsoleOracle.setMinimumSize(new java.awt.Dimension(40, 0));
        jPanelFactorOracle.setLayout(new java.awt.GridLayout(5, 1));

        jPanelFactorOracle.setBorder(new javax.swing.border.TitledBorder("Factor Oracle"));
        jPanelFactorOracle.setMaximumSize(getPreferredSize());
        jTextFieldPattern.setText("GTATGTA");
        jTextFieldPattern.setToolTipText("Introduce aqu\u00ed el pattern del Factor Oracle deseado");
        jTextFieldPattern.setMargin(new java.awt.Insets(1, 1, 2, 4));
        jTextFieldPattern.setMaximumSize(new java.awt.Dimension(50, 20));
        jTextFieldPattern.setPreferredSize(new java.awt.Dimension(100, 20));
        jPanelFactorOracle.add(jTextFieldPattern);

        jButtonStart.setText("Empezar");
        jButtonStart.setToolTipText("Comenzar con el Factor Oracle introducido");
        jButtonStart.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonStart.setMaximumSize(getPreferredSize());
        jButtonStart.setMinimumSize(getPreferredSize());
        jButtonStart.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStartActionPerformed(evt);
            }
        });

        jPanelFactorOracle.add(jButtonStart);

        jButtonReset.setText("Resetear");
        jButtonReset.setToolTipText("Resetear el Factor Oracle actual");
        jButtonReset.setEnabled(false);
        jButtonReset.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonReset.setMaximumSize(getPreferredSize());
        jButtonReset.setMinimumSize(getPreferredSize());
        jButtonReset.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResetActionPerformed(evt);
            }
        });

        jPanelFactorOracle.add(jButtonReset);

        jPanelSteps.setLayout(new java.awt.GridLayout(1, 0));

        jPanelSteps.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonStepBack.setText("<<");
        jButtonStepBack.setToolTipText("Retroceder un paso del Factor Oracle");
        jButtonStepBack.setEnabled(false);
        jButtonStepBack.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonStepBack.setMaximumSize(new java.awt.Dimension(50, 23));
        jButtonStepBack.setMinimumSize(new java.awt.Dimension(50, 23));
        jButtonStepBack.setPreferredSize(new java.awt.Dimension(50, 23));
        jButtonStepBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStepBackActionPerformed(evt);
            }
        });

        jPanelSteps.add(jButtonStepBack);

        jButtonStep.setText(">>");
        jButtonStep.setToolTipText("Avanzar un paso del Factor Oracle");
        jButtonStep.setEnabled(false);
        jButtonStep.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonStep.setMaximumSize(new java.awt.Dimension(50, 23));
        jButtonStep.setMinimumSize(getPreferredSize());
        jButtonStep.setPreferredSize(new java.awt.Dimension(50, 23));
        jButtonStep.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStepActionPerformed(evt);
            }
        });

        jPanelSteps.add(jButtonStep);

        jPanelFactorOracle.add(jPanelSteps);

        jButtonComplete.setText("Completar");
        jButtonComplete.setToolTipText("Completar el Factor Oracle\n");
        jButtonComplete.setEnabled(false);
        jButtonComplete.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButtonComplete.setMaximumSize(getPreferredSize());
        jButtonComplete.setMinimumSize(getPreferredSize());
        jButtonComplete.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonComplete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCompleteActionPerformed(evt);
            }
        });

        jPanelFactorOracle.add(jButtonComplete);

        jPanelConsoleOracle.add(jPanelFactorOracle);

        jPanelRedrawing.setLayout(new java.awt.GridBagLayout());

        jPanelRedrawing.setBorder(new javax.swing.border.TitledBorder("Redibujado"));
        jPanelRedrawing.setMaximumSize(getPreferredSize());
        jTextFieldSize.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextFieldSize.setText("30");
        jTextFieldSize.setToolTipText("Tama\u00f1o de los nodos del FactorOracle");
        jTextFieldSize.setEnabled(false);
        jTextFieldSize.setMaximumSize(getPreferredSize());
        jTextFieldSize.setMinimumSize(getPreferredSize());
        jTextFieldSize.setPreferredSize(new java.awt.Dimension(60, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanelRedrawing.add(jTextFieldSize, gridBagConstraints);

        jButtonResizeOK.setText("OK");
        jButtonResizeOK.setToolTipText("Cambiar el tama\u00f1o de los nodos del FactorOracle indicados por el campo superior");
        jButtonResizeOK.setEnabled(false);
        jButtonResizeOK.setMaximumSize(getPreferredSize());
        jButtonResizeOK.setMinimumSize(getPreferredSize());
        jButtonResizeOK.setPreferredSize(new java.awt.Dimension(60, 23));
        jButtonResizeOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResizeOKActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanelRedrawing.add(jButtonResizeOK, gridBagConstraints);

        jButtonResizeBigger.setText("+");
        jButtonResizeBigger.setToolTipText("Aumentar en un pixel el tama\u00f1o actual del Factor Oracle");
        jButtonResizeBigger.setEnabled(false);
        jButtonResizeBigger.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonResizeBigger.setMaximumSize(getPreferredSize());
        jButtonResizeBigger.setMinimumSize(getPreferredSize());
        jButtonResizeBigger.setPreferredSize(new java.awt.Dimension(40, 23));
        jButtonResizeBigger.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResizeBiggerActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        jPanelRedrawing.add(jButtonResizeBigger, gridBagConstraints);

        jButtonResizeSmaller.setText("-");
        jButtonResizeSmaller.setToolTipText("Disminuir en un pixel el tama\u00f1o actual del Factor Oracle");
        jButtonResizeSmaller.setEnabled(false);
        jButtonResizeSmaller.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonResizeSmaller.setMaximumSize(getPreferredSize());
        jButtonResizeSmaller.setMinimumSize(getPreferredSize());
        jButtonResizeSmaller.setPreferredSize(new java.awt.Dimension(40, 23));
        jButtonResizeSmaller.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResizeSmallerActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        jPanelRedrawing.add(jButtonResizeSmaller, gridBagConstraints);

        jCheckBoxFitToScreen.setSelected(true);
        jCheckBoxFitToScreen.setText("fit to screen");
        jCheckBoxFitToScreen.setToolTipText("Ajusta el tama\u00f1o del Factor Oracle para un mejor visualizado en la ventana actual");
        jCheckBoxFitToScreen.setMinimumSize(getPreferredSize());
        jCheckBoxFitToScreen.setPreferredSize(new java.awt.Dimension(100, 23));
        jCheckBoxFitToScreen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxFitToScreenActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        jPanelRedrawing.add(jCheckBoxFitToScreen, gridBagConstraints);

        jButtonMoveToStart.setText("Centrar");
        jButtonMoveToStart.setToolTipText("Mover el Factor Oracle a la posici\u00f3n inicial");
        jButtonMoveToStart.setEnabled(false);
        jButtonMoveToStart.setMaximumSize(getPreferredSize());
        jButtonMoveToStart.setMinimumSize(getPreferredSize());
        jButtonMoveToStart.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonMoveToStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMoveToStartActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanelRedrawing.add(jButtonMoveToStart, gridBagConstraints);

        jPanelConsoleOracle.add(jPanelRedrawing);

        jPanelHelp.setLayout(new java.awt.GridLayout(2, 1));

        jPanelHelp.setMaximumSize(getPreferredSize());
        jButtonBOM.setText("BOM");
        jButtonBOM.setToolTipText("Realizar una b\u00fasqueda BOM usando el Factor Oracle actual\n");
        jButtonBOM.setEnabled(false);
        jButtonBOM.setMaximumSize(getPreferredSize());
        jButtonBOM.setMinimumSize(getPreferredSize());
        jButtonBOM.setPreferredSize(new java.awt.Dimension(100, 23));
        jButtonBOM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonBOMActionPerformed(evt);
            }
        });

        jPanelHelp.add(jButtonBOM);

        jButtonHelp.setText("Ayuda");
        jButtonHelp.setToolTipText("Ayuda de los controles de esta Consola");
        jButtonHelp.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonHelp.setMaximumSize(getPreferredSize());
        jButtonHelp.setMinimumSize(getPreferredSize());
        jButtonHelp.setPreferredSize(new java.awt.Dimension(100, 23));
        jPanelHelp.add(jButtonHelp);

        jPanelConsoleOracle.add(jPanelHelp);

        getContentPane().add(jPanelConsoleOracle);

        setBounds(0, 0, 136, 419);
    }//GEN-END:initComponents

    private void jButtonBOMActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBOMActionPerformed
        doGotoBOM();
    }//GEN-LAST:event_jButtonBOMActionPerformed

    private void jButtonStepBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStepBackActionPerformed
        doStepBack();
    }//GEN-LAST:event_jButtonStepBackActionPerformed
    private void jCheckBoxFitToScreenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxFitToScreenActionPerformed
        doFitToScreen();
    }//GEN-LAST:event_jCheckBoxFitToScreenActionPerformed
    private void jButtonMoveToStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMoveToStartActionPerformed
        doMoveToStart();
    }//GEN-LAST:event_jButtonMoveToStartActionPerformed
    private void jButtonStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStartActionPerformed
        doStart();
    }//GEN-LAST:event_jButtonStartActionPerformed
    private void jButtonCompleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCompleteActionPerformed
        doComplete();
    }//GEN-LAST:event_jButtonCompleteActionPerformed
    private void jButtonResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResetActionPerformed
        doReset();
    }//GEN-LAST:event_jButtonResetActionPerformed
    private void jButtonStepActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStepActionPerformed
        doStep();
    }                                               private void jButtonResizeOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-LAST:event_jButtonStepActionPerformed
        doResize();//GEN-FIRST:event_jButtonResizeOKActionPerformed
    }//GEN-LAST:event_jButtonResizeOKActionPerformed
    private void jButtonResizeBiggerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResizeBiggerActionPerformed
        doBigger();
    }//GEN-LAST:event_jButtonResizeBiggerActionPerformed
    private void jButtonResizeSmallerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResizeSmallerActionPerformed
        doSmaller();
    }//GEN-LAST:event_jButtonResizeSmallerActionPerformed
    private void doStart(){
        
        //Cogemos el contenido del textfield, lo ponemos en maysculas y comprobamos
        //si est vaco o no. En caso de estarlo no hacemos nada
        if( jTextFieldPattern.getText().length()>0){
            
            String title, pattern;
            
            pattern = jTextFieldPattern.getText().toUpperCase();
            jTextFieldPattern.setText(pattern);
            
            if(pattern.length()>30)title = pattern.substring(0, 30) + "..."; 
            else title = pattern.substring(0, pattern.length());
            title+=" (" + pattern.length() + " caracteres)";
            
            jFrameMyCanvasOracle.setTitle("Factor Oracle - " + title);
            
            co.start(pattern);
            co.moveToDefaultStartPoint();
            doFitToScreen();
                
            jButtonComplete.setEnabled(true);
            jButtonReset.setEnabled(true);
            jButtonStep.setEnabled(true);
            jButtonStepBack.setEnabled(false);
            jButtonResizeBigger.setEnabled(true);
            jButtonResizeSmaller.setEnabled(true);
            jButtonResizeOK.setEnabled(true);
            jTextFieldSize.setEnabled(true);
            jButtonMoveToStart.setEnabled(true);
            jButtonBOM.setEnabled(true);
            
            co.repaint();
        }
    }
    private void doComplete(){
        
        co.complete();
        jButtonComplete.setEnabled(false);
        jButtonStep.setEnabled(false);
        jButtonStepBack.setEnabled(false);
        co.repaint();
    }
    private void doReset(){
        
        co.reset();
        jButtonComplete.setEnabled(true);
        jButtonStep.setEnabled(true);
        jButtonStepBack.setEnabled(false);
        co.repaint();
    }
    private void doStep(){
        
        //Si hemos realizado el ltimo paso (el Factor Oracle est completo)
        if(co.step()){
            jButtonStep.setEnabled(false);
            jButtonComplete.setEnabled(false);
        }
        else jButtonStepBack.setEnabled(true);
        co.repaint();
    }
    private void doStepBack(){
        
        if(co.stepBack()==0) jButtonStepBack.setEnabled(false);
        jButtonStep.setEnabled(true);
        jButtonComplete.setEnabled(true);
        co.repaint();
    }
    private void doBigger(){
        
        jTextFieldSize.setText(Integer.toString(co.makeItBigger()));
        if(jCheckBoxFitToScreen.isSelected()) jCheckBoxFitToScreen.doClick();
        co.setFitToScreen(false);
        co.repaint();
    }
    private void doSmaller(){
        
        jTextFieldSize.setText(Integer.toString(co.makeItSmaller()));
        if(jCheckBoxFitToScreen.isSelected()) jCheckBoxFitToScreen.doClick();
        co.setFitToScreen(false);
        co.repaint();
    }
    private void doResize(){
        int size=-1;
        try{ //nos aseguramos que lo que haya en el jTextFieldSize sea un entero
            size = Integer.parseInt(jTextFieldSize.getText());
        }catch(NumberFormatException e){}
        if(size>0 && co.isStarted()){
            co.resizeFactorOracle(new Dimension(size, size));
            if(jCheckBoxFitToScreen.isSelected()) jCheckBoxFitToScreen.doClick();
            co.setFitToScreen(false);
            co.repaint();
        }
    }
    private void doFitToScreen(){
        
        //Si no hemos hecho un "Empezar" no hacemos la llamada a fitToScreen()
        if(jCheckBoxFitToScreen.isSelected() && co.isStarted()){
            jTextFieldSize.setText(Integer.toString(co.fitToScreen()));
            co.setFitToScreen(true);
            co.repaint();
        }
        else co.setFitToScreen(false);
    }
    private void doMoveToStart(){
        
        co.moveToDefaultStartPoint();
        co.repaint();
    }
    private void doMove(int x, int y){
        
        if(co.isStarted())
        {
            co.moveFromStartPoint(x, y);
            co.repaint();
        }
    }
    private void doClose(){
            
        jFrameMyCanvasOracle.dispose();
        dispose();
    }
    private void doGotoBOM(){
        new ConsoleBOM(co.getPattern());
        doClose();
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ConsoleOracle().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonBOM;
    private javax.swing.JButton jButtonComplete;
    private javax.swing.JButton jButtonHelp;
    private javax.swing.JButton jButtonMoveToStart;
    private javax.swing.JButton jButtonReset;
    private javax.swing.JButton jButtonResizeBigger;
    private javax.swing.JButton jButtonResizeOK;
    private javax.swing.JButton jButtonResizeSmaller;
    private javax.swing.JButton jButtonStart;
    private javax.swing.JButton jButtonStep;
    private javax.swing.JButton jButtonStepBack;
    private javax.swing.JCheckBox jCheckBoxFitToScreen;
    private javax.swing.JPanel jPanelConsoleOracle;
    private javax.swing.JPanel jPanelFactorOracle;
    private javax.swing.JPanel jPanelHelp;
    private javax.swing.JPanel jPanelRedrawing;
    private javax.swing.JPanel jPanelSteps;
    private javax.swing.JTextField jTextFieldPattern;
    private javax.swing.JTextField jTextFieldSize;
    // End of variables declaration//GEN-END:variables
    
}
